import { ConversationTurnEvent } from './types.js';
import type { ContentBlock } from '@aws-sdk/client-bedrock-runtime';
import { GraphqlRequestExecutor } from './graphql_request_executor';
export type MutationResponseInput = {
    input: {
        conversationId: string;
        content: ContentBlock[];
        associatedUserMessageId: string;
    };
};
/**
 * This class is responsible for sending a response produced by Bedrock back to AppSync
 * in a form of mutation.
 */
export declare class ConversationTurnResponseSender {
    private readonly event;
    private readonly graphqlRequestExecutor;
    /**
     * Creates conversation turn response sender.
     */
    constructor(event: ConversationTurnEvent, graphqlRequestExecutor?: GraphqlRequestExecutor);
    sendResponse: (message: ContentBlock[]) => Promise<void>;
    private createMutationRequest;
}
//# sourceMappingURL=conversation_turn_response_sender.d.ts.map