import { ExecutableTool } from '../types';
import type { ToolInputSchema, ToolResultContentBlock } from '@aws-sdk/client-bedrock-runtime';
import { DocumentType } from '@smithy/types';
import { GraphqlRequestExecutor } from '../graphql_request_executor';
/**
 * A tool that use GraphQl queries.
 */
export declare class GraphQlTool implements ExecutableTool {
    name: string;
    description: string;
    inputSchema: ToolInputSchema;
    readonly graphQlEndpoint: string;
    private readonly query;
    readonly accessToken: string;
    private readonly graphqlRequestExecutor;
    /**
     * Creates GraphQl Tool
     */
    constructor(name: string, description: string, inputSchema: ToolInputSchema, graphQlEndpoint: string, query: string, accessToken: string, graphqlRequestExecutor?: GraphqlRequestExecutor);
    execute: (input: DocumentType | undefined) => Promise<ToolResultContentBlock>;
}
//# sourceMappingURL=graphql_tool.d.ts.map