"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.upperCaseConversationFieldName = exports.getConversationMessageListQueryInputTypeName = exports.getConversationMessageListQueryName = exports.getConversationMessageGetQueryName = exports.getFunctionStackName = exports.getAssistantMutationFieldName = exports.getMessageSubscriptionFieldName = exports.getConversationMessageTypeName = exports.getConversationTypeName = exports.CONVERSATION_MESSAGE_GET_QUERY_INPUT_TYPE_NAME = exports.LIST_MESSAGES_INDEX_NAME = exports.CONVERSATION_MESSAGES_REFERENCE_FIELD_NAME = void 0;
const graphql_transformer_common_1 = require("graphql-transformer-common");
const pluralize_1 = __importDefault(require("pluralize"));
exports.CONVERSATION_MESSAGES_REFERENCE_FIELD_NAME = 'conversationId';
exports.LIST_MESSAGES_INDEX_NAME = 'gsi-ConversationMessage.conversationId.createdAt';
exports.CONVERSATION_MESSAGE_GET_QUERY_INPUT_TYPE_NAME = 'ID';
const getConversationTypeName = (config) => `Conversation${(0, exports.upperCaseConversationFieldName)(config)}`;
exports.getConversationTypeName = getConversationTypeName;
const getConversationMessageTypeName = (config) => `ConversationMessage${(0, exports.upperCaseConversationFieldName)(config)}`;
exports.getConversationMessageTypeName = getConversationMessageTypeName;
const getMessageSubscriptionFieldName = (config) => `onCreateAssistantResponse${(0, exports.upperCaseConversationFieldName)(config)}`;
exports.getMessageSubscriptionFieldName = getMessageSubscriptionFieldName;
const getAssistantMutationFieldName = (config) => `createAssistantResponse${(0, exports.upperCaseConversationFieldName)(config)}`;
exports.getAssistantMutationFieldName = getAssistantMutationFieldName;
const getFunctionStackName = (config) => `${(0, exports.upperCaseConversationFieldName)(config)}ConversationDirectiveLambdaStack`;
exports.getFunctionStackName = getFunctionStackName;
const getConversationMessageGetQueryName = (config) => `getConversationMessage${(0, exports.upperCaseConversationFieldName)(config)}`;
exports.getConversationMessageGetQueryName = getConversationMessageGetQueryName;
const getConversationMessageListQueryName = (config) => `listConversationMessage${(0, pluralize_1.default)((0, exports.upperCaseConversationFieldName)(config))}`;
exports.getConversationMessageListQueryName = getConversationMessageListQueryName;
const getConversationMessageListQueryInputTypeName = (config) => `ModelConversationMessage${(0, exports.upperCaseConversationFieldName)(config)}FilterInput`;
exports.getConversationMessageListQueryInputTypeName = getConversationMessageListQueryInputTypeName;
const upperCaseConversationFieldName = (config) => (0, graphql_transformer_common_1.toUpper)(config.field.name.value);
exports.upperCaseConversationFieldName = upperCaseConversationFieldName;
//# sourceMappingURL=name-values.js.map