"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createS3AssetMappingTemplateGenerator = exports.createResolverFunctionDefinition = void 0;
const graphql_transformer_core_1 = require("@aws-amplify/graphql-transformer-core");
const createResolverFunctionDefinition = (definition) => {
    var _a, _b;
    return {
        ...definition,
        dataSource: (_a = definition.dataSource) !== null && _a !== void 0 ? _a : NONE_DATA_SOURCE,
        substitutions: (_b = definition.substitutions) !== null && _b !== void 0 ? _b : EMPTY_SUBSTITUTIONS,
    };
};
exports.createResolverFunctionDefinition = createResolverFunctionDefinition;
const createS3AssetMappingTemplateGenerator = (parentName, slotName, fieldName) => (config, code) => graphql_transformer_core_1.MappingTemplate.s3MappingFunctionCodeFromString(code, `${parentName}.${fieldName(config)}.${slotName}.js`);
exports.createS3AssetMappingTemplateGenerator = createS3AssetMappingTemplateGenerator;
const NONE_DATA_SOURCE = () => undefined;
const EMPTY_SUBSTITUTIONS = () => ({});
//# sourceMappingURL=resolver-function-definition.js.map