"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConversationDirective = void 0;
const name = 'conversation';
const definition = `
  directive @${name}(
    aiModel: String!
    systemPrompt: String!
    functionName: String
    handler: ConversationHandlerFunctionConfiguration
    tools: [ToolMap]
    inferenceConfiguration: ConversationInferenceConfiguration
  ) on FIELD_DEFINITION
  
  input ConversationHandlerFunctionConfiguration {
    functionName: String!
    eventVersion: String!
  }

  input ToolMap {
    name: String
    description: String
  }

  input ConversationInferenceConfiguration {
    maxTokens: Int
    temperature: Float
    topP: Float
  }
`;
const defaults = {};
exports.ConversationDirective = {
    name,
    definition,
    defaults,
};
//# sourceMappingURL=conversation.js.map